package org.jboss.tools.sapphire;

import org.eclipse.sapphire.modeling.IModelElement;
import org.eclipse.sapphire.modeling.ListProperty;
import org.eclipse.sapphire.modeling.ModelElementList;
import org.eclipse.sapphire.modeling.ModelElementType;
import org.eclipse.sapphire.modeling.annotations.GenerateImpl;
import org.eclipse.sapphire.modeling.annotations.Type;
import org.eclipse.sapphire.modeling.xml.annotations.XmlListBinding;

@GenerateImpl

public interface IComposite  extends IModelElement {

    ModelElementType TYPE = new ModelElementType( IComposite.class );

    // *** Services ***

    @Type( base = IService.class )
    @XmlListBinding( mappings = @XmlListBinding.Mapping( element = "service", type = IService.class ) )
    
    ListProperty PROP_SERVICES = new ListProperty( TYPE, "Services" );
    
    ModelElementList<IService> getServices();
}
